/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.gtask.data;

import android.database.Cursor;//操作SQLite数据库的对象
import android.util.Log;//Log是Android中用于记录日志的工具类。

import net.micode.notes.tool.GTaskStringUtils;//GTasks中用于处理GoogleTask字符串的工具类。

import org.json.JSONException;//用于处理JSON解析异常的异常类。
import org.json.JSONObject;//org.json包中用于处理JSON对象的类。

//处理与任务相关的元数据
public class MetaData extends Task {
    private final static String TAG = MetaData.class.getSimpleName();

    private String mRelatedGid = null;
    //用于设置元数据信息。它接收一个gid和一个包含元数据信息的JSONObject作为参数，
    // 并将gid添加到元数据信息中。然后将元数据信息转换为字符串，并将其设置为任务的备注信息。最后将任务名称设置为"Meta Note Name"。

    public void setMeta(String gid, JSONObject metaInfo) {
        try {
            metaInfo.put(GTaskStringUtils.META_HEAD_GTASK_ID, gid);
        } catch (JSONException e) {
            Log.e(TAG, "failed to put related gid");
        }
        setNotes(metaInfo.toString());
        setName(GTaskStringUtils.META_NOTE_NAME);
    }
    //用于获取相关的gid。
    public String getRelatedGid() {
        return mRelatedGid;
    }

    //用于判断是否值得保存。如果备注信息不为null，则返回true，否则返回false。
    @Override
    public boolean isWorthSaving() {
        return getNotes() != null;
    }

    //从远程的JSON对象中设置任务的内容。它首先调用父类的方法设置任务的内容，
    // 然后从备注信息中提取相关的gid，并将其赋值给mRelatedGid。
    @Override
    public void setContentByRemoteJSON(JSONObject js) {
        super.setContentByRemoteJSON(js);
        if (getNotes() != null) {
            try {
                JSONObject metaInfo = new JSONObject(getNotes().trim());
                mRelatedGid = metaInfo.getString(GTaskStringUtils.META_HEAD_GTASK_ID);
            } catch (JSONException e) {
                Log.w(TAG, "failed to get related gid");
                mRelatedGid = null;
            }
        }
    }

    //被标记为不应该被调用，因此抛出了IllegalAccessError异常。
    @Override
    public void setContentByLocalJSON(JSONObject js) {
        // this function should not be called
        throw new IllegalAccessError("MetaData:setContentByLocalJSON should not be called");
    }

    //被标记为不应该被调用，因此抛出了IllegalAccessError异常。
    @Override
    public JSONObject getLocalJSONFromContent() {
        throw new IllegalAccessError("MetaData:getLocalJSONFromContent should not be called");
    }

    //被标记为不应该被调用，因此抛出了IllegalAccessError异常。
    @Override
    public int getSyncAction(Cursor c) {
        throw new IllegalAccessError("MetaData:getSyncAction should not be called");
    }

}
//用于处理与任务相关的元数据，例如与Google任务相关的gid值。
//封装了操作元数据的方法，并提供了一些辅助方法来获取和设置相关的gid值。
